<div class="card">

  <div class="card-body" style="max-height: 67vh;height: 67vh; overflow: auto;">

    <ng-container *ngFor="let element of form.elementList;let elementIndex=index">

      <div class="row " style="margin-bottom: 10px">
        <div class="col card p-0" [title]="element.guide">

          <ng-container [ngSwitch]="element.newElementType">

            <div class="card-header">
              <h6>
                <span *ngIf="element.required===true" style="color: #fc5959">*</span>
                <ng-container *ngSwitchCase="newElementType.TEXT_FIELD">متن کوتاه -</ng-container>
                <ng-container *ngSwitchCase="newElementType.NUMERICAL"> عدد -</ng-container>
                <ng-container *ngSwitchCase="newElementType.TEXT_AREA">متن بلند(توضیحی) -</ng-container>
                <ng-container *ngSwitchCase="newElementType.COMBO_BOX">لیستی -</ng-container>
                <ng-container *ngSwitchCase="newElementType.CHECK_BOX">گزینه ای چند انتخابی -</ng-container>
                <ng-container *ngSwitchCase="newElementType.RADIO_BUTTON">گزینه ای تک انتخابی -</ng-container>
                <ng-container *ngSwitchCase="newElementType.DATE">تاریخ -</ng-container>
                <ng-container *ngSwitchCase="newElementType.DATE_RANGE">بازه تاریخی -</ng-container>
                <ng-container *ngSwitchCase="newElementType.TIME">ساعت -</ng-container>
                عنوان :
                {{ element.questionTitle }}
              </h6>

            </div>
            <div class="card-body-content  p-4 cursor-pointer">

              <!--        TEXT_FIELD-->
              <ng-container *ngSwitchCase="newElementType.TEXT_FIELD">
                <input type="text" class="form-control"
                       [id]="'inputText'+element.id"
                       [placeholder]="element.placeHolder?element.placeHolder:''"
                       [maxLength]="element.maxLength"
                       [minLength]="element.minLength"
                       [required]="element.required"

                >
              </ng-container>
              <!--        NUMERICAL-->
              <ng-container *ngSwitchCase="newElementType.NUMERICAL">
                <input type="number" class="form-control"
                       [id]="'inputText'+element.id"
                       [placeholder]="element.placeHolder?element.placeHolder:''"
                       [maxLength]="element.maxLength"
                       [minLength]="element.minLength"
                >
              </ng-container>

              <!--        TEXT_AREA-->
              <ng-container *ngSwitchCase="newElementType.TEXT_AREA">
                                <textarea class="form-control"
                                          placeholder="{{element.placeHolder?element.placeHolder:''}}"
                                          style="max-height: 80px;min-height: 80px;max-width: 100%;min-width: 100%"
                                          [id]="'inputTextArea'+element.id"
                                          [maxLength]="element.maxLength"
                                          [minLength]="element.minLength"
                                ></textarea>

              </ng-container>
              <!--        DATE-->
              <ng-container *ngSwitchCase="newElementType.DATE">
                <ng-container [ngTemplateOutlet]="DateInputTemp"></ng-container>
              </ng-container>
              <ng-container *ngSwitchCase="newElementType.DATE_RANGE">
                <ng-container [ngTemplateOutlet]="DateInputTemp"></ng-container>
              </ng-container>
              <ng-template #DateInputTemp>
                <input type="text" class="form-control"
                       [id]="'inputDate'+element.id"
                       [placeholder]="element.placeHolder?element.placeHolder:''"
                       [maxLength]="element.maxLength"
                       [minLength]="element.minLength"
                >
              </ng-template>
              <!--        COMBO_BOX-->
              <ng-container *ngSwitchCase="newElementType.COMBO_BOX">

                <ng-select dir="rtl" [id]="'comboBox'+element.id"

                           [placeholder]="element.placeHolder?element.placeHolder:''"
                           bindValue="id"
                           bindLabel="value"
                           [items]=" element.newOptionList"
                           dropdownPosition="bottom">
                </ng-select>


              </ng-container>
              <!--        CHECK_BOX-->
              <ng-container *ngSwitchCase="newElementType.CHECK_BOX">
                <ng-container *ngFor="let option  of element.newOptionList">
                  <div class="row ">
                    <div class="d-flex align-items-start">
                      <input type="checkbox"
                             [id]="'checkbox'+option.id"
                             [placeholder]="element.placeHolder?element.placeHolder:''"
                             [maxLength]="element.maxLength"
                             [minLength]="element.minLength"
                      >
                      <span>&nbsp;&nbsp;{{option.value}}</span>
                    </div>
                  </div>
                </ng-container>
              </ng-container>
              <!--        RADIO_BUTTON-->
              <ng-container *ngSwitchCase="newElementType.RADIO_BUTTON">
                <ng-container *ngFor="let option  of element.newOptionList">
                  <label style="width: 100%;cursor: pointer">
                    <div class="row ">
                      <div class="d-flex align-items-start">
                        <input type="radio"
                               [id]="'radio'+option.id"
                               name="radio{{element.id}}"
                               [placeholder]="element.placeHolder?element.placeHolder:''"
                               [maxLength]="element.maxLength"
                               [minLength]="element.minLength"
                        >
                        <span>&nbsp;&nbsp;{{option.value}}</span>
                      </div>
                    </div>
                  </label>
                </ng-container>
              </ng-container>

              <!--        TIME-->
              <ng-container *ngSwitchCase="newElementType.TIME">

                <div class="row ">
                  <div class="col-2">
                    <label> دقیقه : </label>
                    <input type="number" min="0" max="59" class="form-control"
                           [id]="'inputTimeminute'+element.id"
                           [placeholder]="'دقیقه'"
                    >
                  </div>
                  <div class="col-2">
                    <label> ساعت : </label>

                    <input type="number" min="0" max="23" class="form-control"
                           [id]="'inputTimeHour'+element.id"
                           [placeholder]="'ساعت'"
                    >
                  </div>


                </div>
              </ng-container>
            </div>

          </ng-container>

        </div>
        <div class="d-flex align-items-center" *ngIf="mode!==actionMode.VIEW">

          <i class="fa fa-arrow-up cursor-pointer  mx-1" *ngIf="elementIndex>0"
             (click)="elementMove('up',elementIndex)"></i>
          <i class="fa fa-arrow-up cursor-not-allowed mx-1 "
             style="color: #9498b0"
             *ngIf="elementIndex===0"></i>
          <i class="fa fa-arrow-down cursor-pointer mx-1 "
             *ngIf="elementIndex+1<form.elementList.length"
             (click)="elementMove('down',elementIndex) "></i>
          <i class="fa fa-arrow-down cursor-not-allowed mx-1 "
             style="color: #9498b0"
             *ngIf="elementIndex+1===form.elementList.length"></i>


          <i class="fa fa-edit cursor-pointer mx-1" (click)=" selectElementForEdit(element)"></i>
          <i class="fa fa-trash cursor-pointer mx-1"
             *ngIf="token===TokenModel.Admin1"
             style="color: #fc5959"
             (click)="form.elementList.splice(elementIndex,1);updateForm()"></i>
        </div>
      </div>
    </ng-container>


  </div>
  <div class="card-footer">
    <!--        <h3> فرم  {{ form.title }} </h3>-->
    <div class="form-group d-flex justify-content-between">
      <button type="button" class="btn btn-info" data-bs-toggle="modal" data-bs-target="#insertFieldsModal"
              *ngIf="mode!==actionMode.VIEW">

        <i class="fa fa-plus-circle"></i>
        افزودن سوال
      </button>


      <div>
        <button type="button" (click)="back()" class="btn btn-warning  mx-2">
          بازگشت
        </button>
        <button type="submit" class="btn btn-success mx-2" *ngIf="mode!==actionMode.VIEW" (click)="updateForm()">
          ذخیره
          <i *ngIf="loadingSubmit" class="fa fa-spinner fa-pulse fa-1x"></i>
          <i class="fa fa-save"></i>
        </button>
      </div>
    </div>
  </div>
</div>


<!-- Modal -->
<div class="modal fade" id="insertFieldsModal" tabindex="-1" aria-labelledby="exampleModalLabel"
     aria-hidden="true">
  <!--<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">-->
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">

      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">
          <i class="fa fa-plus-circle" style="color: gray"></i>
          افزودن سوال
        </h5>
        <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>


      <div class="modal-body">
        <div class="col-6">
          <div class="form-group">

          </div>
        </div>
        <form class=" form" [formGroup]="htmlForm" (ngSubmit)="onSubmit()">
          <div class="col-md-12">
            <div class="row">

              <!--            newElementType-->
              <div class="col-6">
                <div class="form-group">
                  <label> نوع</label>
                  <span style="color: #fc5959">*</span>

                  <ng-select dir="rtl" id="newElementType"
                             [(ngModel)]="newElement.newElementType"
                             bindValue="id"
                             bindLabel="title"
                             [items]="newElementTypeList"
                             name="newElementType" formControlName="newElementType">

                  </ng-select>

                </div>
              </div>
              <!--            questionTitle-->
              <div class="col-6">
                <div class="form-group">
                  <label>عنوان</label>
                  <span style="color: #fc5959">*</span>

                  <input type="text" class="form-control" formControlName="questionTitle"
                         [pattern]="myPattern.TITLEFa"
                         [(ngModel)]="newElement.questionTitle">


                </div>
              </div>
            </div>
            <div class="row">
              <!--            guide-->
              <div class="col-6">
                <div class="form-group">
                  <label>راهنما</label>
                  <input type="text" class="form-control" formControlName="guide"
                         [pattern]="myPattern.TITLEFa"
                         [(ngModel)]="newElement.guide">

                </div>
              </div>
              <!--                required-->
              <div class="col-6">
                <div class="form-group">
                  <label> اجباری / اختیاری</label>
                  <ng-select dir="rtl" id="required"
                             [(ngModel)]="newElement.required"
                             bindValue="value"
                             bindLabel="title"
                             [items]="requiredList"
                             name="required" formControlName="required">
                  </ng-select>
                </div>
              </div>
            </div>

            <div class="row">
              <!--            placeHolder-->
              <ng-container
                      *ngIf="newElement.newElementType!==newElementType.RADIO_BUTTON&&
                                   newElement.newElementType!==newElementType.CHECK_BOX&&
                                   newElement.newElementType!==newElementType.TIME">
                <div class="col-6">
                  <div class="form-group">
                    <label>متن جانما</label>
                    <input type="text" class="form-control" formControlName="placeHolder"
                           [pattern]="myPattern.TITLEFa"
                           [(ngModel)]="newElement.placeHolder">

                  </div>
                </div>
              </ng-container>

            </div>

            <!--mask-pattern-dri-->
            <!--                TEXT_FIELD -->
            <ng-container
                    *ngIf="newElement.newElementType===newElementType.TEXT_FIELD">

              <div class="row">
                <!--            pattern-->
                <div class="col-6">
                  <div class="form-group">
                    <label> فرمت پترن</label>
                    <input type="text" class="form-control" formControlName="pattern"
                           placeholder="فرمت پترن وارد شود"
                           [(ngModel)]="newElement.pattern">
                  </div>
                </div>
                <!--            mask-->
                <div class="col-6">
                  <div class="form-group">
                    <label> فرمت مسک </label>
                    <input type="text" class="form-control" formControlName="mask"
                           placeholder="فرمت مسک وارد شود"
                           [(ngModel)]="newElement.mask">
                  </div>
                </div>
                <!--            dir-->
                <div class="col-6">
                  <div class="form-group">
                    <label> فرمت چینش </label>
                    <ng-select dir="rtl" id="direction"
                               [(ngModel)]="newElement.dir"
                               bindValue="value"
                               bindLabel="title"
                               [items]="directionList"
                               name="direction" formControlName="direction">
                    </ng-select>

                  </div>
                </div>

              </div>
            </ng-container>

            <!--mask-pattern-dri!!!!!!!!!!!!!-->

            <!--max-min-->
            <!--                TEXT_FIELD && TEXT_AREA && NUMERICAL-->
            <ng-container
                    *ngIf="newElement.newElementType===newElementType.TEXT_FIELD
              ||newElement.newElementType===newElementType.TEXT_AREA
              ||newElement.newElementType===newElementType.NUMERICAL
">

              <div class="row">
                <!--            minLength-->
                <div class="col-6">
                  <div class="form-group">
                    <label>حداقل طول</label>
                    <input type="number" class="form-control" formControlName="minLength"
                           [pattern]="myPattern.number"
                           min="0"
                           placeholder="مقدار عددی وارد شود"
                           [(ngModel)]="newElement.minLength">
                  </div>
                </div>
                <!--            maxLength-->
                <div class="col-6">
                  <div class="form-group">
                    <label>حداکثر طول</label>
                    <input type="number" class="form-control" formControlName="maxLength"
                           min="0"
                           [pattern]="myPattern.number"
                           placeholder="مقدار عددی وارد شود"
                           [(ngModel)]="newElement.maxLength">

                  </div>
                </div>

              </div>
            </ng-container>

            <!--max-min!!!!!!!!!!!!!-->

            <!--                optionList-->
            <!--                RADIO_BUTTON && COMBO_BOX && CHECK_BOX-->
            <ng-container *ngIf="newElement.newElementType===newElementType.COMBO_BOX||
                                     newElement.newElementType===newElementType.RADIO_BUTTON||
                                     newElement.newElementType===newElementType.CHECK_BOX
                                           ">
              <div class="row" style="margin-bottom: 10px">
                <div class="col">

                  <label>نام گزینه</label>
                  <input type="text" class="form-control" formControlName="optionTitle"
                         [pattern]="myPattern.TITLEFa"
                         [(ngModel)]="newOption.value">
                </div>
                <div class="d-flex align-items-end">

                  <button (click)="addOption()" [disabled]="!newOption.value"
                          *ngIf="mode!==actionMode.VIEW" class="btn btn-success mt-2">
                    <i class="fa fa-plus-circle"></i>
                    {{newOption.id ? 'ویرایش' : 'افزودن'}}
                  </button>
                </div>
              </div>
              <div style="max-height: 200px;
    overflow: auto;
    background-color: #f1f1f1;">

                <ng-container *ngFor="let option of newElement.newOptionList;let optionIndex=index">
                  <div class="row m-2">

                    <div class="col card">
                      <label>{{option.value}}</label>
                    </div>
                    <div class="d-flex align-items-center">
                      <i class="fa fa-edit cursor-pointer ml-2 mr-2"
                         (click)=" selectOptionForEdit(option)"></i>
                      <i class="fa fa-trash cursor-pointer"
                         style="color: #fc5959"
                         (click)="newElement.newOptionList.splice(optionIndex,1)"></i>
                    </div>
                  </div>
                </ng-container>
              </div>
            </ng-container>
            <!--                optionList!!!!-->
            <!--                CHECK_BOX-->
            <ng-container
                    *ngIf="newElement.newElementType===newElementType.CHECK_BOX">

              <div class="row">

                <!--            minItemSelectable-->
                <div class="col-6">
                  <div class="form-group">
                    <label>حداقل گزینه قابل انتخاب</label>
                    <span style="color: #fc5959">*</span>

                    <input type="number" class="form-control" formControlName="minItemSelectable"
                           min="0"
                           [max]="newElement.newOptionList.length"
                           [pattern]="myPattern.number"
                           placeholder="مقدار عددی وارد شود"
                           [(ngModel)]="newElement.minItemSelectable">

                  </div>
                </div>
                <!--            maxItemSelectable-->
                <div class="col-6">
                  <div class="form-group">
                    <label>حداکثر گزینه قابل انتخاب</label>
                    <span style="color: #fc5959">*</span>

                    <input type="number" class="form-control" formControlName="maxItemSelectable"
                           min="0"
                           [pattern]="myPattern.number"
                           [max]="newElement.newOptionList.length"
                           placeholder="مقدار عددی وارد شود"
                           [(ngModel)]="newElement.maxItemSelectable">

                  </div>
                </div>
              </div>
            </ng-container>


          </div>

          <div class="modal-footer mt-4 d-flex justify-content-between">
            <button type="button" class="btn btn-danger" data-bs-dismiss="modal">بستن</button>
            <button type="submit" class="btn btn-success">
              <i class="fa fa-save"></i>
              تایید
            </button>
          </div>
        </form>

      </div>


    </div>
  </div>
</div>
